local name, ns = ...
local debug = ns.debug
local Addon = _G[name]

local templates = {}

function Addon:GetTemplates()
	return templates
end

templates["Faction"] = [[return Faction() or '']]
templates["Name with title"] = [[local name = NameFull(unit)
if not name then
  return UNKNOWN
end
local _, class = UnitClass(unit)
local color = "%1"
if UnitIsPlayer(unit) then
  color = Colorize("%1", ClassColor(unit))
else
  color = Colorize("%1", HostileColor(unit))
end
name = name:gsub(Name(unit), color)
return name
]]
templates["NameFull"] = [[local name = NameFull(unit)
if not name then
  return UNKNOWN
end
local _, class = UnitClass(unit)
local color = "%1"
if UnitIsPlayer(unit) then
  color = Colorize("%1", ClassColor(unit))
else
  color = Colorize("%1", HostileColor(unit))
end
name = name:gsub(Name(unit), color)
return name
]]
templates["GuildWithRank"] = [[local guild, rankname, rankindex = GetGuildInfo(unit)
if not guild then
  guild = NPCGuild()
  if not guild then return '' end
  return "<%s>", guild
end
local pguild, _, prankindex = GetGuildInfo("player")
if pguild == guild then
  guild = ("|cff00cc00<%s>|r"):format(guild)
  local rankcolor
  if rankindex > prankindex then
    rankcolor = "|cffff0000%s|r"
  elseif rankindex < prankindex then
    rankcolor = "|cff00ff00%s|r"
  else
    rankcolor = "|cffffff00%s|r"
  end
  rankname = rankcolor:format(rankname)
else
  guild = ("<%s>"):format(guild)
end
return "%s (%d) of %s", rankname, rankindex, guild
]]
templates["Faction"] = [[return Faction() or '']]
templates["LevelClassRace"] = [[local level, race = Level(unit), SmartRace(unit)
local class = ""
if UnitIsPlayer(unit) then
  class = Colorize(Class(unit), ClassColor(unit))
else
  class = ""
end
level = Colorize(level, DifficultyColor(unit))
local diff = ShortClassification(unit)
local icon = GenderIcon(unit)
if icon then
  return "Level %s%s %s %s |T%s:12|t", level, diff, race, class, icon
else
  return "Level %s%s %s %s", level, diff, race, class
end
]]
templates["TalentsWithIcon"] = [[
local icon = TalentSpecIcon(unit)
local name = TalentSpecName(unit) or ''
if icon then
  return '|T%s:12|t %s', icon, name
else
  return name
end
]]

templates["Target"] = [[local name = Name(unit .. "target")
if not name then
  return NONE
elseif name == UnitName("player") then
  return Colorize(("<<%s>>"):format(YOU), 0, 0, 255)
else
  return Colorize(name, SmartClassColor(unit .. "target"))
end
]]
templates["Status"] = [[return Offline(unit) or AFK(unit) or DND(unit) or Status(unit) or '']]
templates["Zone"] = "return Zone() or ''"
templates["TalentDetail"] = "return TalentSpec(unit) or ''"